import 'package:flutter/services.dart';
import 'package:zebrautility/ZebraPrinter.dart';

class Zebrautility {
  static const MethodChannel _channel = const MethodChannel('zebrautility');

  static Future<ZebraPrinter> getPrinterInstance ({Function onPrinterFound(String name, String ipAddress, bool isWifi),
      Function onPrinterDiscoveryDone, Function(int errorCode, String errorText) onDiscoveryError, Function onChangePrinterStatus(String status, String color), Function onPermissionDenied}) async {
    String id = await _channel.invokeMethod("getInstance");
    ZebraPrinter printer = ZebraPrinter(
        id, onPrinterFound, onPrinterDiscoveryDone, onDiscoveryError, onChangePrinterStatus, onPermissionDenied: onPermissionDenied);
    return printer;
  }
}
